#include <nbody\Symp6s.h>
#include <math.h>
#include <iostream>
#include <stdlib.h>
//#include "dgdsysNBV.h"


int SINITIALIZED = 0;
double Dt0;
void(*derivs)(double, double[], double[]);

int neq, ndof;
double *TM1, *TM2;
//////////// 6th Order Integrator //////////////////////////
double d6[8];
double c6[8];

int InitSI(int numeq, double Dt0) //Changed
{
	neq = numeq;
	ndof = (neq - 1) / 2;
	//	ndof2 = 2 * ndof;
	double w1, w2, w3, w0;
	//vasilis constants 6th
	w1 = -1.177679984178877203859769906557630747557;
	w2 = 0.2355732133593562427353873545143869705498;
	w3 = 0.784513610477561851297423345386050641537;
	w0 = (1. - 2.*(w1 + w2 + w3));

	d6[0] = w3;	c6[0] = w3 / 2.;
	d6[1] = w2;	c6[1] = (w3 + w2) / 2.;
	d6[2] = w1;	c6[2] = (w2 + w1) / 2.;
	d6[3] = w0;	c6[3] = (w1 + w0) / 2.;
	d6[4] = w1;	c6[4] = c6[3];
	d6[5] = w2;	c6[5] = c6[2];
	d6[6] = w3;	c6[6] = c6[1];
	d6[7] = 0.;	c6[7] = c6[0];

	TM1 = new double[neq];
	TM2 = new double[neq];

	SINITIALIZED = 1;
	return 1;
}
void CloseSI()
{
	delete[] TM1;
	delete[] TM2;
	SINITIALIZED = 0;
}
//////////////////////////////////////////////////////////////////////////////////////
void symplectic_6_pos(double cc[], double dt, int c6indx) // Changed
														  /// for position 
{
	for (int i = 1; i <= ndof; i++) cc[i] += dt*c6[c6indx] * cc[i + ndof];
}
void symplectic_6_vel(double cc[], double dvf[], double dt, int d6indx) // Changed
																		/// for velocity
{
	for (int i = 1; i <= ndof; i++) cc[i + ndof] += dt*d6[d6indx] * dvf[i];
}
/// 
void Symplectic6thSTEP(double y[], double dt)
{
	double *dxdy = TM2;
	for (int i = 0; i < 7; i++)
	{
		symplectic_6_pos(y, dt, i);
		//		DV(C, dv);
		derivs(y[0], y, dxdy);
		symplectic_6_vel(y, dxdy, dt, i);
	}
	symplectic_6_pos(y, dt, 7);
	y[0] += dt;
}

void Symplectic6thRUN(double yin[], int n, double dt, double yout[])
{
	double *y = TM1;
	for (int i = 0; i < neq; i++) y[i] = yin[i];
	double t0 = y[0];
	for (int i = 0; i < n; i++) Symplectic6thSTEP(y, dt);
	for (int i = 0; i<neq; i++) yout[i] = y[i];
	return; 
}


