//D nb Problem Orbits
// 7/3/2017
#pragma warning (disable : 4996)

#include <stdio.h>
#include <nbody\dgdsysNBs.h>
#include <stdlib.h>
#include <string.h>
#include <nbody\giroeNBs.h>
#include <fstream>
#include <conio.h>


using namespace std;

#define NMAXBODIES 100

int ReadConfig(char *fname, OEDEF oeb[]); 

extern double *radius;
//double radd;

double *mm;
OEDEF oeb[NMAXBODIES];
double t_metric;
double dt, DT, Ener0, Lang0;
int NN, slf, Nsteps;
char Bfname[128] = "ttt\0";

void file_input()
{
	
		printf("Enter Work File name :"); scanf("%s", Bfname); getchar();
	
	//----------------------------------------------------
	//Initial Settings
	char fn_cnf[128];
	strcpy(fn_cnf, Bfname); strcat(fn_cnf, ".txt"); 
	//initconfig
	int err = ReadConfig(fn_cnf, oeb);  
	if (err) { printf("Read_Config error %d\n", err); return; }
	return;

}



void file_change(char system_name[])
{
		char fn_cnf1[128]="\0";
	strcpy(fn_cnf1, system_name); strcat(fn_cnf1, ".txt");
		ReadConfig(fn_cnf1, oeb);
		return;
}


void ShowIC(double X0[]) // Changed
{
	FILE *fil = fopen("i000.txt", "wt");
	int i;
	fprintf(fil, "Project NBS-V / GV2007-12 v.2.0\n");
	fprintf(fil, "Work %s\n", Bfname);
	printf("Work %s\n", Bfname);
	fprintf(fil, "-----------------------------------------------------------\n");
	fprintf(fil, "Bodies = %d\n", NB);
	printf("Bodies = %d\n", NB);
	printf("Sbody mass0=%lf\n", mm[0]);
	fprintf(fil, "Mass "); for (i = 1; i <= NB; i++) fprintf(fil, "%8lf  ", mm[i]); fprintf(fil, "\n");
	fprintf(fil, "Sema "); for (i = 1; i <= NB; i++) fprintf(fil, "%8lf  ", oeb[i].a); fprintf(fil, "\n");
	fprintf(fil, "Ecce "); for (i = 1; i <= NB; i++) fprintf(fil, "%8lf  ", oeb[i].e); fprintf(fil, "\n");
	fprintf(fil, "Incl "); for (i = 1; i <= NB; i++) fprintf(fil, "%8.5lf  ", oeb[i].i); fprintf(fil, "\n");
	fprintf(fil, "Mean "); for (i = 1; i <= NB; i++) fprintf(fil, "%8.5lf  ", oeb[i].elpos); fprintf(fil, "\n");
	fprintf(fil, "omeg "); for (i = 1; i <= NB; i++) fprintf(fil, "%8.5lf  ", oeb[i].omega); fprintf(fil, "\n");
	fprintf(fil, "Omeg "); for (i = 1; i <= NB; i++) fprintf(fil, "%8.5lf  ", oeb[i].Omega); fprintf(fil, "\n");

	fprintf(fil, "\nInertial system\n");
	fprintf(fil, " N   x              y             z             xd              yd              zd\n");
	double xb[7];
	for (int i = 1; i <= NB; i++) {
		fprintf(fil, "%2d. ", i); GetBodyPos(i, X0, xb);
		for (int k = 1; k <= 6; k++) fprintf(fil, "% 12.10lf  ", xb[k]); fprintf(fil, "\n");
	}
	fprintf(fil, "\n");
	Ener0 = Energy(X0);
	Lang0 = AngularMomentum(X0);
	fprintf(fil, "Energy=%15.14lf   AngMomentum=%15.14lf\n ", Ener0, Lang0);
	printf("Energy=%15.14lf   AngMomentum=%15.14lf\n ", Ener0, Lang0);
	printf("------------------------------------------------------------\n");
	printf("Evolution time span (t-metric=%4f) = %d x %3f = %f \n", t_metric, NN, DT*t_metric, NN*DT*t_metric);
	fprintf(fil, "Evolution time span (t-metric=%4f) = %d x %3f = %f \n", t_metric, NN, DT*t_metric, NN*DT*t_metric);
	printf("------------------------------------------------------------\n");
	/*	fprintf(fil,"\n Initial variations\n");
	for(int i=NDOF+1;i<=2*NDOF;i++) fprintf(fil,"v[%d]=%2.1f ",i,X0[i]); fprintf(fil,"\n");
	for(int i=3*NDOF+1;i<=4*NDOF;i++) fprintf(fil,"v[%d]=%2.1f ",i,X0[i]); fprintf(fil,"\n");
	*/	fclose(fil);
	system("notepad i000.txt");
	printf("press <ENTER> to continue"); getchar();
}



int ReadConfig(char *fname, OEDEF oeb[])
{
	FILE *fil = fopen(fname, "rt");
	if (fil == NULL) return -100;
	//BSVAR bs;
	int n, nbodies, pd; double p, Ms;
	Readfstr(fil); n = fscanf(fil, "%d", &pd); if (n != 1) { fclose(fil); return -1; }
	else nbodies = pd;
	Readfstr(fil); n = fscanf(fil, "%lf", &p); if (n != 1) { fclose(fil); return -5; }
	else dt = p;
	Readfstr(fil); n = fscanf(fil, "%d", &pd); if (n != 1) { fclose(fil); return -5; }
	else Nsteps = pd;
	DT = Nsteps*dt;
	Readfstr(fil); n = fscanf(fil, "%lf", &p); if (n != 1) { fclose(fil); return -6; }
	else Ms = p;
	mm = new double[nbodies + 1];
	//oeb=new OEDEF[NB+1];
	//--------------------------------------------------------------
	mm[0] = Ms;
	Readfstr(fil);
	for (int i = 1; i <= nbodies; i++)
	{
		double m, a, e, incl, M, om, Om,radd;
		n = fscanf(fil, "%lf %lf %lf %lf %lf %lf %lf %lf", &m, &a, &e, &incl, &M, &om, &Om, &radd);   // 
		if (n != 8) { fclose(fil); return -9 - i; }
		mm[i] = m; oeb[i].a = a; oeb[i].e = e; oeb[i].i = incl;
		oeb[i].elpos = M; oeb[i].omega = om; oeb[i].Omega = Om;
		oeb[i].inputangle = 1; oeb[i].modedisplay = 1;
		radius[i] = radd;
	}
	//--------------------------------------------------------------
	double tp1physunits;
	Readfstr(fil); n = fscanf(fil, "%lf", &p); if (n != 1) { fclose(fil); return -nbodies - 1; }
	else tp1physunits = p;
	Readfstr(fil); n = fscanf(fil, "%d", &NN); if (n != 1) { fclose(fil); return -nbodies - 3; }
	fclose(fil);
	//---------------------------------------------------------------
	for (int i = 0; i <= nbodies; i++) if (mm[i]<0) return -102;//check
	if (!InitDSys(nbodies, mm, dt)) return -103;
	//UNITS
	double a = oeb[1].a;
	double tp1sysunits = pi2*sqrt(a*a*a / (mm[0] + mm[1]));
	t_metric = tp1physunits / tp1sysunits;
	return 0;
}
