// NBS project
//System/Body Position elements
//*************************** N planets + Sun ********************


#define FRTINY 1.0e-5

#include <nbody\dgdsysNBs.h>
#include <nbody\giroeNBs.h>
#include <nbody\gTools.h>


void HelioToBary(double **xb);


//######  X  <--->   OE   ########################


void GetSystemPosV(OEDEF Q[], double X0[])
//Q:array of OE of bodies, X0:SystemPos
{
	//double xb[7];
	//double **xb;
	//xb=Alloc2Dspace(NB+1,7);  //##??## Alloc in init
	double xb[7];
	for (int i = 1; i <= NB; i++)
	{
		InitRestroe(0, mas[i], mas[0], 0, A_metric, 0);  //##??##mas[0]
		GetInertialFromOrbital(Q[i], xb);
		SetSystemPos(i, xb, X0);
	}
	return;
}


void GetBodiesOE(double X[], OEDEF Q[])
{
	double xs[7], xb[7];
	OEPOS q;
	SBodyPos(X, xs);//##??##
	for (int i = 1; i <= NB; i++)
	{
		GetBodyPos(i, X, xb);//barycentric
		for (int j = 1; j<7; j++) xb[j] -= xs[j]; //set heliocentric pos
		InitRestroe(0, mas[i], mas[0], 0, A_metric, 0); //##??##mas[0]
		GetOrbitalElements(xb, &q, 1);
		OEPOStoOEDEF(q, &Q[i]);
	}
}


//#########################################################

void SetSystemPos(int i, double xb[], double X0[]) //Changed
												   //body pos to system pos
{
	X0[0] = 0.0;
	for (int k = 0; k<3; k++) {
		int index = 3 * i - 2 + k;
		X0[index] = xb[k + 1]; //pos
		X0[index + NDOF] = xb[k + 4];
	}
}




void GetBodyPos(int body, double X[], double XB[]) //Changed
												   //X[NEQ]:systemPos, XB[7]: bodypos
{
	XB[0] = X[0];
	for (int k = 0; k<3; k++) { int index = 3 * body - 2 + k;; XB[k + 1] = X[index]; XB[k + 4] = X[index + NDOF]; }
}


//############################################################

void GetRangles(int Pr, int Qr, OEDEF q1, OEDEF q2, Rangles *R, int mode_180_pi)
{
	OEPOS o1, o2;
	OEDEFtoOEPOS(q1, &o1); OEDEFtoOEPOS(q2, &o2);
	if (o1.modedisplay != o2.modedisplay) return; //different angle units
	int md = o1.modedisplay;
	int mp = mode_180_pi;
	double lth = Pr*o1.lamda - (Pr + Qr)*o2.lamda;
	R->th1 = lth + Qr*o1.omegabar;
	R->th2 = lth + Qr*o2.omegabar;
	R->sig1 = R->th1 / Qr;
	R->sig2 = R->th2 / Qr;
	R->Dom = o2.omegabar - o1.omegabar;
	R->resonance = o1.meanmotion / o2.meanmotion;
	FixAngle(&R->th1, md, mp); FixAngle(&R->th2, md, mp);
	FixAngle(&R->sig1, md, mp); FixAngle(&R->sig2, md, mp); FixAngle(&R->Dom, md, mp);
}


//--- tool : fix angle value ----
void FixAngle(double *x, int mode_deg, int mode_180_pi)
{
	double w, W = *x;
	if (mode_deg) w = 360.0; else w = pi2;
	W += (10 * w); W = fmod(W, w);
	if (fabs(w - W)<FRTINY)   W = 0;
	if (fabs(W - w / 2)<FRTINY) W = w / 2;
	if (mode_180_pi&&W>w / 2) W -= w;
	*x = W;
}



//### Local AUX ########################################################

void HelioToBary(double **xb)
{
	double xsg[7]; //CM
	for (int j = 1; j <= 6; j++)
	{
		double sum = 0;
		for (int i = 1; i <= NB; i++) sum += mas[i] * xb[i][j];
		xsg[j] = sum / mtot;
	}
	for (int i = 1; i <= NB; i++)
		for (int j = 1; j <= 6; j++) xb[i][j] -= xsg[j];
}



